package com.rjconsultores.integracaoreceitadespesa.entidades;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

public class DespesaReceita {
	private String dataLancamento; // DD/MM/YYYY
	private String codigoEmpresa; //	011	003	Numrico
	private final String codigoFilial = "001"; //	014	003	Numrico
	private String localArrecadao; //	017	005	Alfanumrico
	private final String numeroDaGuia = "                         "; //	022	025	Alfanumrico
	private String dataMovimento; //	047	010	Alfanumrico
	private final String usuarioGlobus = "TOTALBUS       ";// 	057	015	Alfanumrico
	private final String turno = "01";//	072	002	Numrico
	private String codigoReceitaDespesa;//	074	010	Numrico CONSTANTE CODIGO_RECEITA_DESPESA_GLOBUS
	private String identificadorReceitaDespesa;//	084	001	Alfanumrico
	private String valorLancamento;//	085	013	Numrico
	private final String numeroContratoTurismo = "0000000000";//	098	010	Numrico
	private final String numeroReciboTurismo = "          ";//	108	010	Alfanumrico
	private final String formaPagamentoTurismo = "00";//	118	002	Numrico
	private final String tipoPagamentoTurismo = "00";//	120	002	Numrico
	private String descricaoDetalhada = "                                                                                                    ";//	122	100	Alfanumrico
	private final String documentoVenda = "000000";//	222	6	Numrico
	private final String tipoDocumentoVenda = " ";//	228	1	Alfanumrico
	private final String numerodocumentoCPG = "0000000000";//	229	10	Numrico
	private final String finalLinha = "*";//	239	1	Alfanumrico
	
	private SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
	
	public DespesaReceita(){
		
	}
	
	public void preencheLinha(List<String> rows){
		rows.add(dataLancamento + codigoEmpresa + codigoFilial + 
				localArrecadao.toUpperCase() +
				numeroDaGuia + dataMovimento + usuarioGlobus + 
				turno + codigoReceitaDespesa + 
				identificadorReceitaDespesa.toUpperCase() + valorLancamento + 
				numeroContratoTurismo + numeroReciboTurismo + 
				formaPagamentoTurismo + tipoPagamentoTurismo + 
				descricaoDetalhada + documentoVenda + tipoDocumentoVenda + 
				numerodocumentoCPG + finalLinha + System.getProperty("line.separator"));
	}
	
	public void setDataLancamento(Date dataLancamento) {
		this.dataLancamento = sdf.format(dataLancamento);
	}

	public void setCodigoEmpresa(Integer codigoEmpresa) {
		this.codigoEmpresa = lpad(codigoEmpresa.toString(), "0", 3);
	}

	public void setLocalArrecadao(Integer localArrecadao) {
		this.localArrecadao = rpad(localArrecadao.toString(), " ", 5);
	}

	public void setDataMovimento(Date dataMovimento) {		
		this.dataMovimento = sdf.format(dataMovimento);
	}

	public void setCodigoReceitaDespesa(Integer codigoReceitaDespesa) {
		if (codigoReceitaDespesa != null){
			this.codigoReceitaDespesa = lpad(codigoReceitaDespesa.toString(), "0", 10);
		} else {
			this.codigoReceitaDespesa = lpad("0", "0", 10);
		}
	}
	
	
	public void setIdentificadorReceitaDespesa(String identificadorReceitaDespesa) {
		this.identificadorReceitaDespesa = identificadorReceitaDespesa.toUpperCase();
	}

	public void setValorLancamento(String valorLanamento) {
		this.valorLancamento = lpad(valorLanamento.toString().replace(",", "").replace(".", ""), "0", 13);
	}

	public void setDescricaoDetalhada(String desc){
		this.descricaoDetalhada = rpad(truncStr(desc, 100), " ", 100);
	}
	
	private String truncStr(String str, int size){
		if (str.length() > size){
			return str.substring(0, size -1);
		} 
		return str;
	}
	public static String lpad(String valueToPad, String filler, int size) {  
        while (valueToPad.length() < size) {  
            valueToPad = filler + valueToPad;  
        }  
        return valueToPad;  
    }  
      
	public static String rpad(String valueToPad, String filler, int size) {  
        while (valueToPad.length() < size) {  
            valueToPad = valueToPad+filler;  
        }  
        return valueToPad;  
    }  
    
}
